#include <stdio.h>

/*
-------------------------------------------------------------------------------
Programa per resoldre sistemes d'equacions lineals
-------------------------------------------------------------------------------
Dades: A la matriu Aij hi van els coeficients del sistema. A la primera 
       columna de la matriu Bij hi van els termes independents.
Resultats: S'imprimeix per pantalla els valors de la solucio del sistema
Dades de prova: Actualment ja n'hi ha unes posades ==>
                x1=1 x2=2 x3=3
Observacions: -
-------------------------------------------------------------------------------
*/

int gaussj(float a[30][30], int n, float b[30][5], int m);

int main()
{

float a[30][30], b[30][5];
int m, n, ires;

/* Dimensions reals del nostre sistema */

m=1;
n=3;

/* Sistema d'equacions */

a[0][0]=2.0;
a[0][1]=1.0;
a[0][2]=1.0;
a[1][0]=1.0;
a[1][1]=2.0;
a[1][2]=1.0;
a[2][0]=1.0;
a[2][1]=1.0;
a[2][2]=2.0;

b[0][0]=7.0;
b[1][0]=8.0;
b[2][0]=9.0;

ires=gaussj(a,n,b,m);

return ires;

}

int gaussj(float a[30][30], int n, float b[30][5], int m)
{
int i, j, k, l, ll, irow, icol, ires, ipiv[50], indxr[50], indxc[50];
float big, pivinv, dum;

ires=0;

for(j=0; j<n; j++) ipiv[j]=0;

for(i=0; i<n; i++) 
	{
	big=0.0;
	for(j=0; j<n; j++) 
		{
		if(ipiv[j]!=1) for(k=0; k<n; k++)
			{
			if(ipiv[k]==0)
				{
				if(abs(a[j][k])>=big)
					{
					big=abs(a[j][k]);
					irow=j;
					icol=k;
					}
				}
			else
				{
				if(ipiv[k]>1) ires=1;
				}
			}
		}
	ipiv[icol]=ipiv[icol]+1;
	if(irow!=icol)
		{
		for(l=0; l<n; l++)
			{
			dum=a[irow][l];
			a[irow][l]=a[icol][l];
			a[icol][l]=dum;
			}
		for(l=0; l<m; l++)
			{
			dum=b[irow][l];
			b[irow][l]=b[icol][l];
			b[icol][l]=dum;
			}
		}
	indxr[i]=irow;
	indxc[i]=icol;
	if(a[icol][icol]==0.0) ires=1;
	pivinv=1.0/(a[icol][icol]); 
	a[icol][icol]=1.0;
	for(l=0; l<n; l++) a[icol][l]=a[icol][l]*pivinv;
	for(l=0; l<m; l++) b[icol][l]=b[icol][l]*pivinv;
	for(ll=0; ll<n; ll++) if(ll!=icol)
		{
		dum=a[ll][icol];
		a[ll][icol]=0.0;
		for(l=0; l<n; l++) a[ll][l]=a[ll][l]-a[icol][l]*dum;
		for(l=0; l<m; l++) b[ll][l]=b[ll][l]-b[icol][l]*dum;
		}
	}
for(l=n-1; l>=0; l--)
	{
	if(indxr[l]!=indxc[l])for(k=0; k<n; k++)
		{
		dum=a[k][indxr[l]];
		a[k][indxr[l]]=a[k][indxc[l]];
		a[k][indxc[l]]=dum;	
		}
	}
for(j=0; j<m; j++) for(i=0; i<n; i++) printf("%f \n",b[i][j]); 

return ires;
}

